\lstset{escapechar=@,style=customc}
\begin{figure}[H]
\centering
\begin{lstlisting}[language=c,firstnumber=1]
#define MAGIC_1ST "LUKS\xba\xbe"
#define MAGIC_2ND "SKUL\xba\xbe"
#define MAGIC_L     6
#define UUID_L     40
#define LABEL_L    48
#define SALT_L     64
#define CSUM_ALG_L 32
#define CSUM_L     64

/*
 * LUKS2 header on-disk.
 *
 * Binary header is followed by JSON area.
 * JSON area is followed by keyslot area and data area,
 * these are described in JSON metadata.
 *
 * Note: uuid, csum_alg are intentionally on the same offset as LUKS1
 * (checksum alg replaces hash in LUKS1)
 *
 * String (char) should be zero terminated.
 * Padding should be wiped.
 * Checksum is calculated with csum zeroed (+ full JSON area).
 */
struct luks2_hdr_disk {
	char		magic[LUKS2_MAGIC_L];
	/* Version 2 */
	uint16_t	version;
	/* in bytes, including JSON area */
	uint64_t	hdr_size;
	/* increased on every update */
	uint64_t	seqid;
	char		label[LUKS2_LABEL_L];
	char	    checksum_alg[LUKS2_CHECKSUM_ALG_L];
	/* unique for every header/offset */
	uint8_t		salt[LUKS2_SALT_L];
	char		uuid[LUKS2_UUID_L];
	/* owner subsystem label */
	char		subsystem[LUKS2_LABEL_L];
	/* offset from device start in bytes */
	uint64_t	hdr_offset;
	char		_padding[184];
	uint8_t		csum[LUKS2_CHECKSUM_L];
	char		_padding4096[7*512];
	/* JSON area starts here */
} __attribute__ ((packed));
\end{lstlisting}
\caption{LUKS2 binary header structure \cite{cryptsetup}.}
\label{fig:luks2hdr_struct}
\end{figure}
